package com.cslab.HomeApp;

import java.util.ArrayList;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

public class ApplianceStatus extends Activity {
	/** Called when the activity is first created. */
	private static final int STATUS_ID_1 = 0;
	private static final int STATUS_ID_2 = 1;
	private static final int STATUS_ID_3 = 2;
	private Intent i;
	private Client client;
	private String Room_Selected, RoomNum;
	private String Con1, Con2, Con3, Con4, Con5, Con6;
	static final private int Failed_Diglog = 1;
	
	public static final String MYPREFS = "mySharedPreferences";
	private String ip;
	private int port;
	@Override
	public void onCreate(Bundle savedInstanceState) {
	    super.onCreate(savedInstanceState);
	    setContentView(R.layout.roomstatus2);
	    
	    // Intent  濡  
	    Intent i = getIntent();
	    TextView Room = (TextView)findViewById(R.id.Room);
	    Room_Selected = i.getStringExtra("data_room");
		Room.setText(Room_Selected);
		
		// û ޼ 
		if(Room_Selected.compareTo("ȹ") == 0)
			RoomNum = "Room1_app";
		else if(Room_Selected.compareTo("Ž") == 0)
			RoomNum = "Room2_app";
		else if(Room_Selected.compareTo("") == 0)
			RoomNum = "Room3_app";
		
		// ȯ  б
		loadPreferences();
		
		// Client ü , ip, port 
		client = new Client();
		client.set_ip_port(ip, port);
		re_frash();
	}

	// Menu Create
	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);
		MenuItem Refrash = menu.add(0, STATUS_ID_1, 0, R.string.Room_Status_Menu1);
		MenuItem Lampcon = menu.add(0, STATUS_ID_2, 0, R.string.Room_Status_Menu2);
		MenuItem Appcon = menu.add(0, STATUS_ID_3, 0, R.string.Room_Status_Menu3);
		
		Refrash.setIcon(R.drawable.refresh);
		Lampcon.setIcon(R.drawable.lightt);
		Appcon.setIcon(R.drawable.fann);
		
		return true;
	}
	
	// Menu Event
	@Override
	public boolean onOptionsItemSelected(MenuItem item){
		super.onOptionsItemSelected(item);
		
		switch(item.getItemId()) {
			case STATUS_ID_1:
				re_frash();
				return true;
			case STATUS_ID_2:
				i = new Intent(this, Lamp_control.class);
				startActivity(i);
				return true;
			case STATUS_ID_3:
				i = new Intent(this, Appliance_control.class);
				startActivity(i);
				return true;
		}
		return false;
	}
	
	// , ޼ ListView 
	public void re_frash() {
		// Client Thread
	    client.set_string(RoomNum);
	    Thread cThread = new Thread(client);
	    cThread.start();
	    
	    message_passing();
	    
	    // ListView 
	    ListView Status1 = (ListView)findViewById(R.id.List1);
	    ListView Status2 = (ListView)findViewById(R.id.List2);
	    
	    final ArrayList<String> StatusItem1 = new ArrayList<String>();
	    StatusItem1.add("߾ӵ : " + Con1);
	    StatusItem1.add(" : " + Con2);
	    StatusItem1.add("ħ : " + Con3);
	    
	    final ArrayList<String> StatusItem2 = new ArrayList<String>();
	    StatusItem2.add(" : " + Con4);
	    StatusItem2.add("ǳ : " + Con5);
	    StatusItem2.add("¿ : " + Con6);
	    
	    final ArrayAdapter<String> List_String1;
	    List_String1 = new ArrayAdapter<String>(this, 
	    		android.R.layout.simple_list_item_1, StatusItem1);
	    
	    final ArrayAdapter<String> List_String2;
	    List_String2 = new ArrayAdapter<String>(this, 
	    		android.R.layout.simple_list_item_1, StatusItem2);
	    
	    Status1.setAdapter(List_String1);
	    Status2.setAdapter(List_String2);
	    List_String1.notifyDataSetChanged();
	    List_String2.notifyDataSetChanged();
	}
	
	// ޼ Parsing Method
	public void message_passing() {
		String Recv_msg = client.get_string(); //   ۹ ޼
		
		// ε  ( '_' token )
		int index1 = Recv_msg.indexOf('_', 1);
		int index2 = Recv_msg.indexOf('_', index1 + 1);
		int index3 = Recv_msg.indexOf('_', index2 + 2);
		int index4 = Recv_msg.indexOf('_', index3 + 2);
		int index5 = Recv_msg.indexOf('_', index4 + 2);
		int index6 = Recv_msg.length();
		
		Log.d("MSG", Integer.toString(index2) + " " +  Integer.toString(index3));
		
		// index  ڿ 
		try{
			Con1 = Recv_msg.substring(0, index1);
			Con2 = Recv_msg.substring(index1 + 1, index2);
			Con3 = Recv_msg.substring(index2 + 1, index3);
			Con4 = Recv_msg.substring(index3 + 1, index4);
			Con5 = Recv_msg.substring(index4 + 1, index5);
			Con6 = Recv_msg.substring(index5 + 1, index6);
		}
		//  ó
		catch(Exception e)
		{
			Con1 = "Not Connect";
			Con2 = "Not Connect";
			Con3 = "Not Connect";
			Con4 = "Not Connect";
			Con5 = "Not Connect";
			Con6 = "Not Connect";
			showDialog(Failed_Diglog);
		}
	}
	
	// Error Dialog
	@Override
	public Dialog onCreateDialog(int id){
		String button1_String = "Ȯ";
		switch(id) {
			case (Failed_Diglog) :
				AlertDialog.Builder Dialog_1 = new AlertDialog.Builder(this);
				Dialog_1.setTitle("");
				Dialog_1.setMessage("  Ȱ ʽϴ.   ¸ ϼ");
				Dialog_1.setPositiveButton(button1_String, null);
				return Dialog_1.create();
		}
		return null;
	}
	
	// ȯ   Load
	public void loadPreferences() {
		int mode = Activity.MODE_PRIVATE;
		SharedPreferences mySharedPreferences = getSharedPreferences(MYPREFS, mode);
		
		ip = mySharedPreferences.getString("ip", "");
		port = mySharedPreferences.getInt("port", 0);
	}
}
