/////////////////////////////////////////////////////////////////////////////////////
//   
/////////////////////////////////////////////////////////////////////////////////////

#ifndef _COMMON_H_
#define _COMMON_H_

// ⺻  
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define ULONG unsigned long

// Ʈũ Ʈ 
#define NETWORK_PORT 10001

// , ATMEGA Ʈ
#define ZIGBEE_BAUD 57600
#define ATMEGA_BAUD 9600

//  ũ
#define MAX_ROOM 3
#define MAX_BUF 128
#define SHORT_BUF 1
#define LONG_BUF 80
#define SENSOR_BUF 44
#define BRIGHT_BUF 10

//  ȣ
#define ROOM1 1
#define ROOM2 2
#define ROOM3 3

// TCP/IP ޼

#define REQ_ERR	0
#define REQ_STAT_1 1
#define REQ_STAT_2 2
#define REQ_STAT_3 3
#define REQ_STAT_4 4
#define REQ_STAT_5 5
#define REQ_STAT_6 6

#define REQ_CON1 7
#define REQ_CON2 8
#define REQ_CON3 9
#define REQ_CON4 10
#define REQ_CON5 11
#define REQ_CON6 12
#define REQ_CON7 13
#define REQ_CON8 14
#define REQ_CON9 15
#define REQ_CON10 16
#define REQ_CON11 17
#define REQ_CON12 18
#define REQ_CON13 19
#define REQ_CON14 20
#define REQ_CON15 21
#define REQ_CON16 22
#define REQ_CON17 23
#define REQ_CON18 24
#define REQ_CON19 25
#define REQ_CON20 26
#define REQ_CON21 27
#define REQ_CON22 28
#define REQ_CON23 29
#define REQ_CON24 30
#define REQ_CON25 31
#define REQ_CON26 32
#define REQ_CON27 33
#define REQ_CON28 34
#define REQ_CON29 35
#define REQ_CON30 36
#define REQ_CON31 37
#define REQ_CON32 38
#define REQ_CON33 39
#define REQ_CON34 40
#define REQ_CON35 41
#define REQ_CON36 42
#define REQ_CON37 43
#define REQ_CON38 44
#define REQ_CON39 45
#define REQ_CON40 46
#define REQ_CON41 47
#define REQ_CON42 48
#define REQ_CON43 49
#define REQ_CON44 50
#define REQ_CON45 51
#define REQ_CON46 52
#define REQ_CON47 53
#define REQ_CON48 54

#define REQ_SET1 100
#define REQ_SET2 101
#define REQ_SET3 102

// TCP/IP ؽƮ ޽
#define TEXT_ROOM1 "Room1_stat\n"
#define TEXT_ROOM2 "Room2_stat\n"
#define TEXT_ROOM3 "Room3_stat\n"
#define TEXT_ROOM1_APP "Room1_app\n"
#define TEXT_ROOM2_APP "Room2_app\n"
#define TEXT_ROOM3_APP "Room3_app\n"
#define TEXT_ROOM1_LAMP1 "Centerlamp1_on\n"
#define TEXT_ROOM1_LAMP2 "Centerlamp1_off\n"
#define TEXT_ROOM1_LAMP3 "Sidelamp1_on\n"
#define TEXT_ROOM1_LAMP4 "Sidelamp1_off\n"
#define TEXT_ROOM1_LAMP5 "Sleeplamp1_on\n"
#define TEXT_ROOM1_LAMP6 "Sleeplamp1_off\n"
#define TEXT_ROOM1_LAMP7 "All_lamp1_on\n"
#define TEXT_ROOM1_LAMP8 "All_lamp1_off\n"
#define TEXT_ROOM1_APP1 "Humidifier1_on\n"
#define TEXT_ROOM1_APP2 "Humidifier1_off\n"
#define TEXT_ROOM1_APP3 "Fan1_on\n"
#define TEXT_ROOM1_APP4 "Fan1_off\n"
#define TEXT_ROOM1_APP5 "Heater1_on\n"
#define TEXT_ROOM1_APP6 "Heater1_off\n"
#define TEXT_ROOM1_APP7 "All_app1_on\n"
#define TEXT_ROOM1_APP8 "All_app1_off\n"

#define TEXT_ROOM2_LAMP1 "Centerlamp2_on\n"
#define TEXT_ROOM2_LAMP2 "Centerlamp2_off\n"
#define TEXT_ROOM2_LAMP3 "Sidelamp2_on\n"
#define TEXT_ROOM2_LAMP4 "Sidelamp2_off\n"
#define TEXT_ROOM2_LAMP5 "Sleeplamp2_on\n"
#define TEXT_ROOM2_LAMP6 "Sleeplamp2_off\n"
#define TEXT_ROOM2_LAMP7 "All_lamp2_on\n"
#define TEXT_ROOM2_LAMP8 "All_lamp2_off\n"
#define TEXT_ROOM2_APP1 "Humidifier2_on\n"
#define TEXT_ROOM2_APP2 "Humidifier2_off\n"
#define TEXT_ROOM2_APP3 "Fan2_on\n"
#define TEXT_ROOM2_APP4 "Fan2_off\n"
#define TEXT_ROOM2_APP5 "Heater2_on\n"
#define TEXT_ROOM2_APP6 "Heater2_off\n"
#define TEXT_ROOM2_APP7 "All_app2_on\n"
#define TEXT_ROOM2_APP8 "All_app2_off\n"

#define TEXT_ROOM3_LAMP1 "Centerlamp3_on\n"
#define TEXT_ROOM3_LAMP2 "Centerlamp3_off\n"
#define TEXT_ROOM3_LAMP3 "Sidelamp3_on\n"
#define TEXT_ROOM3_LAMP4 "Sidelamp3_off\n"
#define TEXT_ROOM3_LAMP5 "Sleeplamp3_on\n"
#define TEXT_ROOM3_LAMP6 "Sleeplamp3_off\n"
#define TEXT_ROOM3_LAMP7 "All_lamp3_on\n"
#define TEXT_ROOM3_LAMP8 "All_lamp3_off\n"
#define TEXT_ROOM3_APP1 "Humidifier3_on\n"
#define TEXT_ROOM3_APP2 "Humidifier3_off\n"
#define TEXT_ROOM3_APP3 "Fan3_on\n"
#define TEXT_ROOM3_APP4 "Fan3_off\n"
#define TEXT_ROOM3_APP5 "Heater3_on\n"
#define TEXT_ROOM3_APP6 "Heater3_off\n"
#define TEXT_ROOM3_APP7 "All_app3_on\n"
#define TEXT_ROOM3_APP8 "All_app3_off\n"

#define TEXT_ROOM1_SET "Room1_set"
#define TEXT_ROOM2_SET "Room2_set"
#define TEXT_ROOM3_SET "Room3_set"

#define ON_TEXT "On"
#define OFF_TEXT "Off"

#define CON_LAMP "lamp"
#define CON_LAMP1 "center_lamp"
#define CON_LAMP2 "side_lamp"
#define CON_LAMP3 "sleep_lamp"

#define CON_APP "appliance"
#define CON_APP1 "humidifier"
#define CON_APP2 "fan"
#define CON_APP3 "heater"

#define CON_SET1 "temputure"
#define CON_SET2 "humidity"

#endif