/////////////////////////////////////////////////////////////////////////////////////
// Zigbee  ø α׷
/////////////////////////////////////////////////////////////////////////////////////

//  
#include "Common.h"
#include "CUBRID.h"

int main()
{
	//  
	int fd;
	int i,j,k;
	int rdcnt, channel, mote_id;
	int con;
	int num[MAX_ROOM] = {1,1,1};
	int count = 0;

	char dev_name[MAX_BUF];
	char buf[SHORT_BUF], buf1[LONG_BUF], buf2[SENSOR_BUF];
	char light[BRIGHT_BUF];
	char header[SHORT_BUF];
	char sql_str[MAX_BUF];

	float temputure = 0, humidity = 0, solor = 0;
	float avrdata;

	// CCI_ERROR ü
	T_CCI_ERROR	error;
	
	//  ø 
	if((fd = open_serial("/dev/ttyUSB0", ZIGBEE_BAUD, 0, 0)) < 0)
		return 0;

	//  ̽ 
	if((con = DB_Connect()) == 0) 
		return 0;

	//  Room ̺ ʱȭ
	for(i = 1; i <= 3; i++) 
	{
		sprintf(sql_str, ROOM_INIT, i);
		manage_data(con, sql_str);
	}

	//   б
	while(1) 
	{
		// о   ӽ ۿ 
		for(i=0;i<80;i++) 
		{
			rdcnt = read(fd,buf,SHORT_BUF);
			if(rdcnt > 0) {
				buf[rdcnt] = '\0';
				buf1[i] = buf[0];
			}
		}

		//    üũ (0x7e, 0x42, 0x1a, 0x01, 0x08)
		for(j=0; j<80; j++) 
		{
			if(buf1[j]==0x7e) {
				if(buf1[j+1]==0x42) {
					if(buf1[j+2]==0x1a) {
						if(buf1[j+3]==0x01) {
							if(buf1[j+4]==0x08) {
								// ۰ 
								printf("Packet\n");
								for(k=0;k<44;k++){
									buf2[k]=buf1[j+k]; 
									printf("%3x",buf2[k]);
								}
								break;
							}
						}
					}
				}
			}		
		}
		printf("\n");

		sleep(1);

		//  ȣ, ä,  
		mote_id = buf2[13];
		channel = buf2[17];
		avrdata = buf2[20] * 256 + buf2[19];

		switch(channel) 
		{
			// 
			case 0:	
				humidity = -4 + (0.0405 * avrdata) + (-2.8 * 1.0E-6) * (avrdata*avrdata);
				break;
			// µ
			case 1:
				temputure = 0.00355 * avrdata;
				break;
			// 
			case 2:
				solor = (avrdata * 1500) / 4096;
				if(solor < 30)
					strcpy(light,"Dark\n");
				else if(solor >= 30 && solor < 75)
					strcpy(light,"Light\n");
				else if(solor >= 75)
					strcpy(light,"Shine\n");
				break;
			case 3:
				break;
			default:
				break;
		}

		//   
		printf("MoteID : %d Chanel : %d Tm : %5.2f  Mo : %.2f Br : %s \n\n", mote_id, channel, temputure, humidity, light);
		
		//    DB 
		if((humidity > 0) && (temputure > 0) == 1) 
		{
			// Room1 
			if(mote_id == 1)
			{
				insert_data(con, mote_id, &num[0], &temputure, &humidity, light);
				num[0]++;
			}
			// Room2 
			else if(mote_id == 2)
			{
				insert_data(con, mote_id, &num[1], &temputure, &humidity, light);
				num[1]++;
			}
			// Room3 
			else if(mote_id == 3)
			{
				insert_data(con, mote_id, &num[2], &temputure, &humidity, light);
				num[2]++;
			}
			count = 0;
		}
	}

	//  ݱ
	DB_Disconnect(con, error);
	close_serial(fd);

	return 0;
}
