/////////////////////////////////////////////////////////////////////////////////////
// Ʈũ Լ 
/////////////////////////////////////////////////////////////////////////////////////

//  
#include "Network.h"
#include <string.h>
#include <netinet/in.h>

//  
int get_temp, get_humi;
int count = 0;
char *pStr;

//  
int OpenNetwork(int nPort)
{
	struct sockaddr_in sServAddr;
	int	nListenSock;
	 
	if((nListenSock = socket(PF_INET, SOCK_STREAM, 0)) < 0)
	{
		perror("Open socket fail\n");
		return nListenSock;
	}
	
	// Clear server address
	bzero((char *)&sServAddr, sizeof(sServAddr));
	// Set server address
	sServAddr.sin_family = AF_INET;
	sServAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	sServAddr.sin_port = htons(nPort);
	
	// Bind()
	if(bind(nListenSock, (struct sockaddr *)&sServAddr, sizeof(sServAddr)) < 0)
	{
		perror("Bind fail\n");
		return -1;
	}
	
	// Listen...
	listen(nListenSock, 1);
	
	return nListenSock;
}

//  ݱ
void CloseNetwork(int nListenSock)
{
	close(nListenSock);
}

// ޼  ó Լ
ULONG NetRecv(int nSock)
{
	char	strBuf[MAX_BUF];
	int		nByte;
	
	// ޼ 
	nByte = read(nSock, strBuf, MAX_BUF);
	if(nByte < 0)
		return REQ_ERR;
	strBuf[nByte] = 0;
	printf("Recv String : %s Recv Byte : %d \n",strBuf, nByte);

	// ROOM1  ޼
	if(strcmp(strBuf, TEXT_ROOM1) == 0)
		return REQ_STAT_1;
	if(strcmp(strBuf, TEXT_ROOM2) == 0)
		return REQ_STAT_2;
	if(strcmp(strBuf, TEXT_ROOM3) == 0)
		return REQ_STAT_3;
	if(strcmp(strBuf, TEXT_ROOM1_APP) == 0)
		return REQ_STAT_4;
	if(strcmp(strBuf, TEXT_ROOM2_APP) == 0)
		return REQ_STAT_5;
	if(strcmp(strBuf, TEXT_ROOM3_APP) == 0)
		return REQ_STAT_6;
	if(strcmp(strBuf, TEXT_ROOM1_LAMP1) == 0)
		return REQ_CON1;
	if(strcmp(strBuf, TEXT_ROOM1_LAMP2) == 0)
		return REQ_CON2;
	if(strcmp(strBuf, TEXT_ROOM1_LAMP3) == 0)
		return REQ_CON3;
	if(strcmp(strBuf, TEXT_ROOM1_LAMP4) == 0)
		return REQ_CON4;
	if(strcmp(strBuf, TEXT_ROOM1_LAMP5) == 0)
		return REQ_CON5;
	if(strcmp(strBuf, TEXT_ROOM1_LAMP6) == 0)
		return REQ_CON6;
	if(strcmp(strBuf, TEXT_ROOM1_LAMP7) == 0)
		return REQ_CON7;
	if(strcmp(strBuf, TEXT_ROOM1_LAMP8) == 0)
		return REQ_CON8;
	if(strcmp(strBuf, TEXT_ROOM1_APP1) == 0)
		return REQ_CON9;
	if(strcmp(strBuf, TEXT_ROOM1_APP2) == 0)
		return REQ_CON10;
	if(strcmp(strBuf, TEXT_ROOM1_APP3) == 0)
		return REQ_CON11;
	if(strcmp(strBuf, TEXT_ROOM1_APP4) == 0)
		return REQ_CON12;
	if(strcmp(strBuf, TEXT_ROOM1_APP5) == 0)
		return REQ_CON13;
	if(strcmp(strBuf, TEXT_ROOM1_APP6) == 0)
		return REQ_CON14;
	if(strcmp(strBuf, TEXT_ROOM1_APP7) == 0)
		return REQ_CON15;
	if(strcmp(strBuf, TEXT_ROOM1_APP8) == 0)

		return REQ_CON16;
	// ROOM2  ޼
	if(strcmp(strBuf, TEXT_ROOM2_LAMP1) == 0)
		return REQ_CON17;
	if(strcmp(strBuf, TEXT_ROOM2_LAMP2) == 0)
		return REQ_CON18;
	if(strcmp(strBuf, TEXT_ROOM2_LAMP3) == 0)
		return REQ_CON19;
	if(strcmp(strBuf, TEXT_ROOM2_LAMP4) == 0)
		return REQ_CON20;
	if(strcmp(strBuf, TEXT_ROOM2_LAMP5) == 0)
		return REQ_CON21;
	if(strcmp(strBuf, TEXT_ROOM2_LAMP6) == 0)
		return REQ_CON22;
	if(strcmp(strBuf, TEXT_ROOM2_LAMP7) == 0)
		return REQ_CON23;
	if(strcmp(strBuf, TEXT_ROOM2_LAMP8) == 0)
		return REQ_CON24;
	if(strcmp(strBuf, TEXT_ROOM2_APP1) == 0)
		return REQ_CON25;
	if(strcmp(strBuf, TEXT_ROOM2_APP2) == 0)
		return REQ_CON26;
	if(strcmp(strBuf, TEXT_ROOM2_APP3) == 0)
		return REQ_CON27;
	if(strcmp(strBuf, TEXT_ROOM2_APP4) == 0)
		return REQ_CON28;
	if(strcmp(strBuf, TEXT_ROOM2_APP5) == 0)
		return REQ_CON29;
	if(strcmp(strBuf, TEXT_ROOM2_APP6) == 0)
		return REQ_CON30;
	if(strcmp(strBuf, TEXT_ROOM2_APP7) == 0)
		return REQ_CON31;
	if(strcmp(strBuf, TEXT_ROOM2_APP8) == 0)
		return REQ_CON32;
	// ROOM3  ޼
	if(strcmp(strBuf, TEXT_ROOM3_LAMP1) == 0)
		return REQ_CON33;
	if(strcmp(strBuf, TEXT_ROOM3_LAMP2) == 0)
		return REQ_CON34;
	if(strcmp(strBuf, TEXT_ROOM3_LAMP3) == 0)
		return REQ_CON35;
	if(strcmp(strBuf, TEXT_ROOM3_LAMP4) == 0)
		return REQ_CON36;
	if(strcmp(strBuf, TEXT_ROOM3_LAMP5) == 0)
		return REQ_CON37;
	if(strcmp(strBuf, TEXT_ROOM3_LAMP6) == 0)
		return REQ_CON38;
	if(strcmp(strBuf, TEXT_ROOM3_LAMP7) == 0)
		return REQ_CON39;
	if(strcmp(strBuf, TEXT_ROOM3_LAMP8) == 0)
		return REQ_CON40;
	if(strcmp(strBuf, TEXT_ROOM3_APP1) == 0)
		return REQ_CON41;
	if(strcmp(strBuf, TEXT_ROOM3_APP2) == 0)
		return REQ_CON42;
	if(strcmp(strBuf, TEXT_ROOM3_APP3) == 0)
		return REQ_CON43;
	if(strcmp(strBuf, TEXT_ROOM3_APP4) == 0)
		return REQ_CON44;
	if(strcmp(strBuf, TEXT_ROOM3_APP5) == 0)
		return REQ_CON45;
	if(strcmp(strBuf, TEXT_ROOM3_APP6) == 0)
		return REQ_CON46;
	if(strcmp(strBuf, TEXT_ROOM3_APP7) == 0)
		return REQ_CON47;
	if(strcmp(strBuf, TEXT_ROOM3_APP8) == 0)
		return REQ_CON48;
	
	//   ޼
	if((strstr(strBuf, TEXT_ROOM1_SET)) != NULL)
	{
		pStr = strtok(strBuf, "_");
		while(pStr != NULL)
		{
			pStr = strtok(NULL, "_");
			if(pStr)
			{
				if(count == 1)
					get_temp = atoi(pStr);
				else if(count == 2)
					get_humi = atoi(pStr);
			}
			count++;
		}
		count = 0;
		return REQ_SET1;
	}
	if((strstr(strBuf, TEXT_ROOM2_SET)) != NULL)
	{
		pStr = strtok(strBuf, "_");
		while(pStr != NULL)
		{
			pStr = strtok(NULL, "_");
			if(pStr)
			{
				if(count == 1)
					get_temp = atoi(pStr);
				else if(count == 2)
					get_humi = atoi(pStr);
			}
			count++;
		}
		count = 0;
		return REQ_SET2;
	}
	if((strstr(strBuf, TEXT_ROOM3_SET)) != NULL)
	{
		pStr = strtok(strBuf, "_");
		while(pStr != NULL)
		{
			pStr = strtok(NULL, "_");
			if(pStr)
			{
				if(count == 1)
					get_temp = atoi(pStr);
				else if(count == 2)
					get_humi = atoi(pStr);
			}
			count++;
		}
		count = 0;
		return REQ_SET3;
	}

	return REQ_ERR;
}

// ޼  ó
void NetSend(int nSock, char *strData)
{
	int nLen = strlen(strData);
	write(nSock, strData, nLen);
}

// Ŭ̾Ʈ     ȹ
void get_Value(int *temp, int *humi)
{
	*temp = get_temp;
	*humi = get_humi;
}