#define LCD_FUNSET 0x38  // 8Ʈ, 2, 5X7 Ʈ
#define LCD_ONOFF 0x0e // ȭ Ŀ ON, Ŀ  
#define LCD_CURSER_OFF 0x0c
#define LCD_ENTMODE 0x06 // Ʈ Ʈ
#define LCD_CLR 0x01 // LCD ȭ Ŭ
#define LCD_SHIFT 0x18 // Ŀ · ̵
#define LCD_CURSER 0x0f // Ŀ 

void lcd_char(unsigned char ch)
// LCD  
{
    LCD_RS = 1; // D.R  
    LCD_RW = 0;
    LCD_DATA = ch;
    LCD_E = 1; // LCD ο̺
    delay_us(40);
    LCD_E = 0;
}

void lcd_command(unsigned char inst)
// LCD ɾ 
{
    LCD_RS = 0; // I.R  
    LCD_RW = 0;
    LCD_DATA = inst;
    LCD_E = 1;
    delay_us(40);
    LCD_E = 0;
}

void lcd_str(unsigned char flash *str)
// flash  ִ str ͸ lcd_charԼ ȣϿ
// ڿ 
{
    while(*str)
    {
        lcd_char(*str);
        str++;
    }           
}

void lcd_str2(unsigned char *str)
// Ϲ ޸  ִ str ͸ lcd_charԼ ȣϿ
// ڿ 
{
    while(*str)
    {
        lcd_char(*str);
        str++;
    }           
}

void lcd_init(void)
// lcd ʱȭ
{
    lcd_command(LCD_FUNSET);
    lcd_command(LCD_CURSER_OFF);
    lcd_command(LCD_ENTMODE);
    lcd_command(LCD_CLR);
}

void lcd_position(unsigned char x, unsigned char y)
// ڿ  ġ 
{
    unsigned char position;
    
    if(y % 2 == 0)
    // 2 ̸̻ y  0 ó
        y = 0;
    else
        y = 1;
        
    if(x > 15)
    // 15ĭ ̸̻ x 15 ó
        x = 0;
    position = y ? x + 0xc0 : x + 0x80;
    // D.D.RAM ǥ ġ 
    // 1 ġ : 0x80, 2 ġ : 0xC0
    //  ġ  ġ ջ
    lcd_command(position);
}